//TCPseverɹעڵԹ ѡtcpͻģʽIPַ
//õIPַ192.168.1.37,˿õĶ˿5000
//ӳɹյTCPsever˷ "This is TCP Server from uC/OS-II."; /* õ */
//Ϊ˫ģͻҲTCPsever˷ݣڻӡյݣҲʾtcpsever˷
//Ϣ"This is TCP Server from uC/OS-II."; /* õ */

#define __TCPSERVER_C


/* Includes ------------------------------------------------------------------*/
#include "tcpserver.h"
#include "lwip/mem.h" /* Ϊ˷ڴ */
#include <lwip/sockets.h> /* ʹBSD Socketӿڱsockets.hͷļ */
#include "includes.h"

#include "app_cfg.h"
/* Private typedef -----------------------------------------------------------*/

/* Private define ------------------------------------------------------------*/
#ifndef TCPSERVER_STK_SIZE          /* tcpserver ʹöջС */
#define TCPSERVER_STK_SIZE  300
#endif

#ifndef LWIP_TCPSERVER_PRIO         /* tcpserver ȼ */
#define LWIP_TCPSERVER_PRIO 15
#endif

#ifndef RECV_BUFFER_SIZE            /* ջС */
#define RECV_BUFFER_SIZE    512
#endif

#ifndef TCPSERVER_PORT_NO
#define TCPSERVER_PORT_NO   5000    /* tcpserver ʹö˿ں */
#endif
/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/
static const char send_data[] = "This is TCP Server from uC/OS-II."; /* õ */
static OS_STK   TcpServerStack[TCPSERVER_STK_SIZE];

/* Private function prototypes -----------------------------------------------*/
static void tcpserv(void* parameter);
static void tcpserver_thread(void* arg);
/* Private functions ---------------------------------------------------------*/
/**
* @brief tcpserver accept tcp connect receive data and output on debug thermal.
* @param void* parameter :unused.
*/
static void tcpserv(void* parameter)
{
   char *recv_data; /* ڽյָ룬һζ̬ڴ */
   u32_t sin_size;
   int sock, connected, bytes_received;
   struct sockaddr_in server_addr, client_addr;
   bool stop = FALSE; /* ֹͣ־ */

   recv_data = mem_malloc(RECV_BUFFER_SIZE); /* õݻ */
   if (recv_data == NULL)
   {
       printf("No memory\n");
       return;
   }

   /* һsocketʹǰҪԤȴָSOCK_STREAMΪTCPsocket */
   if ((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
   {
       /* ʧܵĴ */
       printf("Socket error\n");

       /* ͷѷĽջ */
       mem_free(recv_data);
       return;
   }

   /* ʼ˵ַ */
   server_addr.sin_family = AF_INET;
   server_addr.sin_port = htons(TCPSERVER_PORT_NO); /* ˹Ķ˿ */
   server_addr.sin_addr.s_addr = INADDR_ANY;
   memset(&(server_addr.sin_zero),8, sizeof(server_addr.sin_zero));

   /* socket˵ַ */
   if (bind(sock, (struct sockaddr *)&server_addr, sizeof(struct sockaddr)) == -1)
   {
       /* ʧ */
       printf("Unable to bind\n");

       /* ͷѷĽջ */
       mem_free(recv_data);
       return;
   }

   /* socketϽм */
   if (listen(sock, 5) == -1)
   {
       printf("Listen error\n");

       /* release recv buffer */
       mem_free(recv_data);
       return;
   }

   printf("\nTCPServer Waiting for client on port %d...\n", TCPSERVER_PORT_NO);
   while(stop != TRUE)
   {
       sin_size = sizeof(struct sockaddr_in);

       /* һͻsocketʽ */
       connected = accept(sock, (struct sockaddr *)&client_addr, &sin_size);
       /* صӳɹsocket */

       /* ܷصclient_addrָ˿ͻ˵ĵַϢ */
       printf("I got a connection from (%s , %d)\n",
                  inet_ntoa(client_addr.sin_addr),ntohs(client_addr.sin_port));

       /* ͻӵĴ */
       while (1)
       {
           /* ݵconnected socket */
           send(connected, send_data, strlen(send_data), 0);

           /* connected socketнݣbuffer1024Сһܹյ1024С */
           bytes_received = recv(connected,recv_data, RECV_BUFFER_SIZE, 0);
           if (bytes_received <= 0)
           {
               if(bytes_received == 0)
                   printf("client close connection.\n");
               else
                   printf("received failed, server close connection.\n");
               
               /* ʧܣرconnected socket */
               lwip_close(connected);
               break;
           }

           /* нյݣĩ */
           recv_data[bytes_received] = '\0';
           if (strcmp(recv_data , "q") == 0 || strcmp(recv_data , "Q") == 0)
           {
               /* ĸqQر */
               printf("receive \"q\" command, close connection.\n");
               lwip_close(connected); // close socket
               break;
           }
           else if (strcmp(recv_data, "exit") == 0)
           {
               /* յexitر */
               printf("receive \"exit\" command, exit tcpserver task.\n");
               lwip_close(connected); // close socket
               stop = TRUE;
               break;
           }
           else
           {
               /* ڿնʾյ */
               printf("RECIEVED DATA = %s \n" , recv_data);
           }
       } // end of while(1)
   } // end of while(stop != TRUE)

	     /* ˳ */
   lwip_close(sock);
	 
   /* ͷŽջ */
   mem_free(recv_data);

   return ;
}

/**
* @brief tcpserver thread
* @param void *arg :unused.
*/
static void tcpserver_thread(void *arg)
{
    tcpserv(arg);
    
    printf("Delete Tcpserver thread.\n");
    OSTaskDel(OS_PRIO_SELF);
}

/**
* @brief start tcpserver
*/
void tcpserver_init(void)
{
    INT8U  os_err;
    
    OSTaskCreate(tcpserver_thread, 
                 NULL, 
                 &TcpServerStack[TCPSERVER_STK_SIZE - 1], 
                 LWIP_TCPSERVER_PRIO
                     );
#if (OS_TASK_NAME_SIZE >= 11)
    OSTaskNameSet(LWIP_TCPSERVER_PRIO, (CPU_INT08U *)"tcpserver", &os_err);
#endif
}

/*-- File end --*/

