/****************************************Copyright (c)****************************************************

                                    webserver
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
** Version:                 
** Descriptions:            
**
*********************************************************************************************************/
#define __WEBSERVER_C


/* Includes ------------------------------------------------------------------*/
#include "webserver.h"

#include "search.h"
#include "webpage.h"
#include <includes.h> 
/* lwIP includes. */
#include "lwip/api.h"
#include "lwip/tcpip.h"
#include "lwip/memp.h"
#include "lwip/stats.h"
#include "netif/loopif.h"
#include "ip.h"

#include "app_cfg.h"

/* Private variables ---------------------------------------------------------*/


/* Private define ------------------------------------------------------------*/
#ifndef WEBSERVER_STK_SIZE          /* WEBSERVER ʹöջС */
#define WEBSERVER_STK_SIZE  300
#endif

#ifndef LWIP_WEBSERVER_PRIO         /*WEBSERVER ȼ */
#define LWIP_WEBSERVER_PRIO 16
#endif

/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/
static OS_STK   WebServerStack[WEBSERVER_STK_SIZE];

/* Private function prototypes -----------------------------------------------*/
static void webserv(void* paramemter);
static void webserver_thread(void* arg);

uint8_t webpage [sizeof(WebSide)];

/* Private function prototypes -----------------------------------------------*/

static  void    vHandler_HTTP(struct netconn  *pstConn);
static  void    __Handler_HTTPGet(struct netconn  *pstConn);


static void  webserv(void* parameter)
{
	struct netconn  *__pstConn, *__pstNewConn; 
    __pstConn = netconn_new(NETCONN_TCP);
    netconn_bind(__pstConn, NULL,80);
    netconn_listen(__pstConn);

	for(;;)
   	{
		  __pstNewConn = netconn_accept(__pstConn);
				
				if(__pstNewConn != NULL)
				{			
					vHandler_HTTP(__pstNewConn);
					while(netconn_delete(__pstNewConn) != ERR_OK)
					{
						OSTimeDlyHMSM(0, 0, 0, 10);
					}
				}
    }
}


static void webserver_thread(void *arg)
{

	  webserv(arg);
    printf("Delete Webserver thread.\n");
    OSTaskDel(OS_PRIO_SELF);


}

/**
* @brief start webserver
*/

void webserver_init(void)
{

			  INT8U  os_err;
			  OSTaskCreate(webserver_thread, 
						   NULL, 
						   &WebServerStack[WEBSERVER_STK_SIZE - 1], 
						   LWIP_WEBSERVER_PRIO
							   );
#if (OS_TASK_NAME_SIZE >= 11)
			  OSTaskNameSet(LWIP_WEBSERVER_PRIO, (CPU_INT08U *)"webserver", &os_err);
#endif
						
}


/*******************************************************************************
* Function Name  : vHandler_HTTP
* Description    : HTTP
* Input          : - pstConn: ָstruct netconnṹָ
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void vHandler_HTTP(struct netconn  *pstConn)
{
	struct netbuf 		*__pstNetbuf;
	INT8S			*__pbData;
	u16_t			__s32Len;

 	__pstNetbuf = netconn_recv(pstConn);
	if(__pstNetbuf != NULL)
	{
		netbuf_data (__pstNetbuf, (void *)&__pbData, &__s32Len );

		if( strstr( (void *)__pbData, "GET" ) != NULL )
		{
			__Handler_HTTPGet(pstConn); 
	    }
	}
	netbuf_delete(__pstNetbuf);	
	netconn_close(pstConn);
}

/*******************************************************************************
* Function Name  : __Handler_HTTPGet
* Description    : HTTPЭGET
* Input          : - pstConn: ָstruct netconnṹָ
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void __Handler_HTTPGet(struct netconn  *pstConn)
{

	memcpy ( webpage , WebSide ,sizeof(WebSide) );
	
	netconn_write(pstConn, "HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n", \
	              strlen("HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n"), NETCONN_COPY);

    netconn_write(pstConn, webpage, sizeof(webpage), NETCONN_COPY);	/* HTTPҳ */
}

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/

